ShingleFilter (Lucene 10.5.1 common API)
Description: declaration: package: org.apache.lucene.analysis.shingle, class: ShingleFilter

Package org.apache.lucene.analysis.shingle

# Class ShingleFilter

java.lang.Object
org.apache.lucene.util.AttributeSource
org.apache.lucene.analysis.TokenStream
org.apache.lucene.analysis.TokenFilter
org.apache.lucene.analysis.shingle.ShingleFilter

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`, `Unwrappable<TokenStream>`

public final class ShingleFilter extends TokenFilter
A ShingleFilter constructs shingles (token n-grams) from a token stream. In other words, it creates combinations of tokens as a single token.

For example, the sentence "please divide this sentence into shingles" might be tokenized into shingles "please divide", "divide this", "this sentence", "sentence into", and "into shingles".

This filter handles position increments > 1 by inserting filler tokens (tokens with termtext "_"). It does not handle a position increment of 0.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource

  `AttributeSource.State`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `DEFAULT_FILLER_TOKEN`
  filler token for when positionIncrement is more than 1
  `static final int`
  `DEFAULT_MAX_SHINGLE_SIZE`
  default maximum shingle size is 2.
  `static final int`
  `DEFAULT_MIN_SHINGLE_SIZE`
  default minimum shingle size is 2.
  `static final String`
  `DEFAULT_TOKEN_SEPARATOR`
  The default string to use when joining adjacent tokens to form a shingle
  `static final String`
  `DEFAULT_TOKEN_TYPE`
  default token type attribute value is "shingle"

  ### Fields inherited from class org.apache.lucene.analysis.TokenFilter

  `input`

  ### Fields inherited from class org.apache.lucene.analysis.TokenStream

  `DEFAULT_TOKEN_ATTRIBUTE_FACTORY`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ShingleFilter(TokenStream input)`
  Construct a ShingleFilter with default shingle size: 2.
  `ShingleFilter(TokenStream input, int maxShingleSize)`
  Constructs a ShingleFilter with the specified shingle size from the `TokenStream` `input`
  `ShingleFilter(TokenStream input, int minShingleSize, int maxShingleSize)`
  Constructs a ShingleFilter with the specified shingle size from the `TokenStream` `input`
  `ShingleFilter(TokenStream input, String tokenType)`
  Construct a ShingleFilter with the specified token type for shingle tokens and the default shingle size: 2

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `end()`
  `boolean`
  `incrementToken()`
  `void`
  `reset()`
  `void`
  `setFillerToken(String fillerToken)`
  Sets the string to insert for each position at which there is no token (i.e., when position increment is greater than one).
  `void`
  `setMaxShingleSize(int maxShingleSize)`
  Set the max shingle size (default: 2)
  `void`
  `setMinShingleSize(int minShingleSize)`
  Set the min shingle size (default: 2).
  `void`
  `setOutputUnigrams(boolean outputUnigrams)`
  Shall the output stream contain the input tokens (unigrams) as well as shingles? (default: true.)
  `void`
  `setOutputUnigramsIfNoShingles(boolean outputUnigramsIfNoShingles)`
  Shall we override the behavior of outputUnigrams==false for those times when no shingles are available (because there are fewer than minShingleSize tokens in the input stream)? (default: false.)
  `void`
  `setTokenSeparator(String tokenSeparator)`
  Sets the string to use when joining adjacent tokens to form a shingle
  `void`
  `setTokenType(String tokenType)`
  Set the type of the shingle tokens produced by this filter.

  ### Methods inherited from class org.apache.lucene.analysis.TokenFilter

  `close, unwrap`

  ### Methods inherited from class org.apache.lucene.util.AttributeSource

  `addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, copyTo, endAttributes, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, reflectAsString, reflectWith, removeAllAttributes, restoreState, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### DEFAULT_FILLER_TOKEN

    public static final String DEFAULT_FILLER_TOKEN
    filler token for when positionIncrement is more than 1
    See Also:
      - Constant Field Values

  - ### DEFAULT_MAX_SHINGLE_SIZE

    public static final int DEFAULT_MAX_SHINGLE_SIZE
    default maximum shingle size is 2.
    See Also:
      - Constant Field Values

  - ### DEFAULT_MIN_SHINGLE_SIZE

    public static final int DEFAULT_MIN_SHINGLE_SIZE
    default minimum shingle size is 2.
    See Also:
      - Constant Field Values

  - ### DEFAULT_TOKEN_TYPE

    public static final String DEFAULT_TOKEN_TYPE
    default token type attribute value is "shingle"
    See Also:
      - Constant Field Values

  - ### DEFAULT_TOKEN_SEPARATOR

    public static final String DEFAULT_TOKEN_SEPARATOR
    The default string to use when joining adjacent tokens to form a shingle
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### ShingleFilter

    public ShingleFilter(TokenStream input, int minShingleSize, int maxShingleSize)
    Constructs a ShingleFilter with the specified shingle size from the `TokenStream` `input`
    Parameters:
      `input` - input stream
      `minShingleSize` - minimum shingle size produced by the filter.
      `maxShingleSize` - maximum shingle size produced by the filter.

  - ### ShingleFilter

    public ShingleFilter(TokenStream input, int maxShingleSize)
    Constructs a ShingleFilter with the specified shingle size from the `TokenStream` `input`
    Parameters:
      `input` - input stream
      `maxShingleSize` - maximum shingle size produced by the filter.

  - ### ShingleFilter

    public ShingleFilter(TokenStream input)
    Construct a ShingleFilter with default shingle size: 2.
    Parameters:
      `input` - input stream

  - ### ShingleFilter

    public ShingleFilter(TokenStream input, String tokenType)
    Construct a ShingleFilter with the specified token type for shingle tokens and the default shingle size: 2
    Parameters:
      `input` - input stream
      `tokenType` - token type for shingle tokens

- ## Method Details

  - ### setTokenType

    public void setTokenType(String tokenType)
    Set the type of the shingle tokens produced by this filter. (default: "shingle")
    Parameters:
      `tokenType` - token tokenType

  - ### setOutputUnigrams

    public void setOutputUnigrams(boolean outputUnigrams)
    Shall the output stream contain the input tokens (unigrams) as well as shingles? (default: true.)
    Parameters:
      `outputUnigrams` - Whether or not the output stream shall contain the input tokens (unigrams)

  - ### setOutputUnigramsIfNoShingles

    public void setOutputUnigramsIfNoShingles(boolean outputUnigramsIfNoShingles)
    Shall we override the behavior of outputUnigrams==false for those times when no shingles are available (because there are fewer than minShingleSize tokens in the input stream)? (default: false.)

    Note that if outputUnigrams==true, then unigrams are always output, regardless of whether any shingles are available.

    Parameters:
      `outputUnigramsIfNoShingles` - Whether or not to output a single unigram when no shingles are available.

  - ### setMaxShingleSize

    public void setMaxShingleSize(int maxShingleSize)
    Set the max shingle size (default: 2)
    Parameters:
      `maxShingleSize` - max size of output shingles

  - ### setMinShingleSize

    public void setMinShingleSize(int minShingleSize)
    Set the min shingle size (default: 2).

    This method requires that the passed in minShingleSize is not greater than maxShingleSize, so make sure that maxShingleSize is set before calling this method.

    The unigram output option is independent of the min shingle size.

    Parameters:
      `minShingleSize` - min size of output shingles

  - ### setTokenSeparator

    public void setTokenSeparator(String tokenSeparator)
    Sets the string to use when joining adjacent tokens to form a shingle
    Parameters:
      `tokenSeparator` - used to separate input stream tokens in output shingles

  - ### setFillerToken

    public void setFillerToken(String fillerToken)
    Sets the string to insert for each position at which there is no token (i.e., when position increment is greater than one).
    Parameters:
      `fillerToken` - string to insert at each position where there is no token

  - ### incrementToken

    public boolean incrementToken() throws IOException
    Specified by:
      `incrementToken` in class `TokenStream`
    Throws:
      `IOException`

  - ### end

    public void end() throws IOException
    Overrides:
      `end` in class `TokenFilter`
    Throws:
      `IOException`

  - ### reset

    public void reset() throws IOException
    Overrides:
      `reset` in class `TokenFilter`
    Throws:
      `IOException`